package main

import (
	"fmt"
	"os"

	"golang.org/x/text/language"

	"golang.org/x/text/message"
)

// Wird beim Bauen per
// -ldflags "-X main.version=$app_version -X main.build=$(due --iso-8601 | tr -d "-" )"
// gesetzt
var (
	version string
	build   string
	printer *message.Printer
	//sugar   *zap.SugaredLogger
)

var serverLangs = []language.Tag{
	language.English, // en fallback
	language.German,  // de
}

var matcher = language.NewMatcher(serverLangs)

var userPrefs = []language.Tag{
	language.Make(os.Getenv("LANG")),
	language.Make("en"),
}

func init() {

	initEnvironment()

	tag, _, _ := matcher.Match(userPrefs...)
	printer = message.NewPrinter(tag)

	initL10n()
	//
	//p := message.NewPrinter(language.English)
	//p.Printf("archive(noun)") // Prints "archive"
	//p.Printf("archive(verb)") // Prints "archive"

	//	p2 := message.NewPrinter(language.German)
	//fmt.Println(printer.Sprintf("Due")) // Prints "Archiv"
	//	p2.Printf("archive(verb)") // Prints "archivieren"
	//initLogger()
}

//func initLogger() {
//	logger, _ := zap.NewDevelopment()
//	defer logger.Sync() // flushes buffer, if any
//
//	sugar = logger.Sugar()
//	sugar.Infow("failed to fetch URL")
//}

func initEnvironment() {
}

/**
 */
func main() {

	activeCommand, arguments, config := NewConfiguration()

	version = "development"
	build = "1.1.1"
	//
	switch activeCommand.Name {

	case "version":
		fmt.Println("Version " + version + " (" + build + ")")
	case "overview":
		subcommand := activeCommand.Active
		switch subcommand.Name {
		case "print":
			err := PrintOverview(config, arguments)
			if err != nil {
				printErrorAndExit(2, err.Error())
			}
		}

	case "meta":
		subcommand := activeCommand.Active
		switch subcommand.Name {
		case "print":
			err := printMeta(config)
			if err != nil {
				printErrorAndExit(2, err.Error())
			}
		}

	case "todos":
		subcommand := activeCommand.Active
		switch subcommand.Name {
		case "print":
			err := printToDoTable(config)
			if err != nil {
				printErrorAndExit(2, err.Error())
			}
		}

	case "items":
		subcommand := activeCommand.Active
		switch subcommand.Name {
		case "print":
			err := printItemTable(config)
			if err != nil {
				printErrorAndExit(2, err.Error())
			}
		}

	}

}
