package main

import (
	"fmt"
	"os/exec"
)

func convertToPDF(source string, output string) string {

	arguments := "/bin/env pandoc "

	arguments += "--number-sections "
	arguments += "--variable \"geometry:a4paper,margin=2cm\" "
	arguments += "--variable fontsize=12pt "
	arguments += "--variable version=2.0 "
	arguments += source + " "
	arguments += "--pdf-engine=xelatex "
	arguments += "--listings "
	arguments += "--template /home/volker.schukai/Downloads/eisvogel/eisvogel.latex "
	arguments += "--columns=5 "
	arguments += "--toc "
	arguments += "--output=" + output

	cmd, err := exec.Command("bash", "-c", arguments).Output()
	if err != nil {
		printErrorAndExit(2, err.Error())
	}

	fmt.Println(string(cmd))

	return string(cmd)

}
